<script lang="ts">
import Vue from 'vue';
import {
  NonprofitOverview,
  SingleCtaBlock,
  QuotesCarousel,
  NonprofitIntro,
} from '../nonprofit/index.vue';
import {
  SideNavigationVariant,
  NextStep,
  NextStepAlt,
  GroupButtons,
  SlpBreadcrumb,
  Faq,
  ReportCta,
  Copy,
  CopyMedia,
} from '../../common/index.vue';
import {
  BySolutionHero,
  BySolutionValueProp,
  BySolutionBenefits,
  BySolutionLink,
  BySolutionIntro,
  BySolutionAccordeon,
  BySolutionCasestudies,
  BySolutionListImage,
  BySolutionShowcase,
} from '../by-solution/index.vue';
import {
  ByIndustryCaseStudies,
  ByIndustryIntro,
  ByIndustrySolutionsBlock,
} from '../by-industry/index.vue';
import {
  OpenSourcePartnersGrid,
  PartnersGridFull,
  OverviewBlocks,
  OpenSourceBlog,
  OpenSourceFormSection,
} from '../../open-source/index.vue';
import { CarouselComponent as ByIndustryQuotesCarousel } from '../by-industry/quotes-carousel/index.vue';
import {
  SolutionsHero,
  SolutionsResourceCards,
  SolutionsVideoFeature,
  ResourceCarousel,
  TierBlock,
  CtaBlock,
} from '../index.vue';
import { CustomerLogos } from '../../devsecops/index.vue';
import { EducationCaseStudyCarousel } from '../education/index.vue';
import {
  StartupsIntro,
  StartupsOverview,
  StartupsLink,
} from '../startups/index.vue';

import {
  AnalyticsInsightsFeatured,
  AnalyticsInsightsShowcaseFaq,
  AnalyticsInsightsCustomerSuccessCard,
} from '../analytics-and-insights/index.vue';

export default Vue.extend({
  name: 'IndustryTemplate',
  components: {
    AnalyticsInsightsFeatured,
    AnalyticsInsightsShowcaseFaq,
    AnalyticsInsightsCustomerSuccessCard,
    TierBlock,
    NextStep,
    NextStepAlt,
    CtaBlock,
    Copy,
    CopyMedia,
    StartupsIntro,
    StartupsOverview,
    StartupsLink,
    BySolutionShowcase,
    SlpBreadcrumb,
    OpenSourceBlog,
    BySolutionHero,
    BySolutionValueProp,
    OpenSourcePartnersGrid,
    OverviewBlocks,
    EducationCaseStudyCarousel,
    BySolutionBenefits,
    SolutionsResourceCards,
    SolutionsVideoFeature,
    ResourceCarousel,
    CustomerLogos,
    BySolutionIntro,
    BySolutionAccordeon,
    PartnersGridFull,
    BySolutionCasestudies,
    BySolutionListImage,
    BySolutionLink,
    SideNavigationVariant,
    SolutionsHero,
    ByIndustryIntro,
    ByIndustryCaseStudies,
    ByIndustryQuotesCarousel,
    ByIndustrySolutionsBlock,
    GroupButtons,
    Faq,
    OpenSourceFormSection,
    ReportCta,
    QuotesCarousel,
    NonprofitOverview,
    SingleCtaBlock,
    NonprofitIntro,
  },
  props: {
    solutions: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <SlpBreadcrumb
        v-if="solutions.breadcrumbs"
        :crumbs="solutions.breadcrumbs"
      />
    </SlpContainer>
    <component
      :is="component.name"
      v-for="component in solutions.components"
      :key="component.name"
      :data="component.data"
      v-bind="component"
    >
      <slot v-if="component.slot_enabled">
        <component
          :is="subcomponent.name"
          v-for="(subcomponent, item) in component.slot_content"
          :key="item"
          v-bind="subcomponent"
        >
          <slot v-if="subcomponent.slot_enabled">
            <component
              :is="contents.name"
              v-for="(contents, subitem) in subcomponent.slot_content"
              :key="subitem"
              v-bind="contents"
            />
          </slot>
        </component>
      </slot>
    </component>
    <NextStepAlt v-if="solutions.next_step_alt" />
    <SlpContainer v-else :variant="solutions.no_gradient ? '' : 'gradient'">
      <NextStep :variant="solutions.nextstep_variant" />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
div[role='main'] {
  overflow: clip;
}
</style>
